---
title: CS101 Topics Pragmatic Programming Assignment
author: Group 18 TODO group number
date: 2025-02-19
licence: sharing is not allowed
CSS: standard.css
toc: true
subject: CS101 2024/25 Topic 4 (Pragmatic Programming)
keywords:
description:
---
# Contents

* [Overview](#overview)
* [Before and After](#before-and-after)
* [Rescources Review](#resources-review)
* [Updates Prompted by User Feedback](#updates-prompted-by-user-feedback)
* [Evaluation](#evaluation)
* [Non-Functional Requirements](#non-functional-requirements)
* [Functional Requirements](#functional-requirements)
* [Reflection](#reflection)
* [Acknowledgements](#acknowledgements)



# Overview

The main points which we planned on changing was the overall colour palette as 
the previous design wasn't very eye-catching or helpful for the user. Therefore, we planned on making the 
design more accessible for those with colour blindess and we also tried to change 
the fonts to help make our program more dyslexia friendly however we were unable to complete all the font
changes that we wanted to.

## Group 18




# Before and after

<figure>
    <img src="Before_GUI.png" alt="Testing" width="425" height="225" >
    <figcaption> <b> This is the interface prior to changes </b> </figcaption> 
</figure>

As shown with the image the GUI interface before we made changes to the code it was very bland and unapealing.
The contrast between the background and the buttons were very similar therefore making it hard to determine what 
was a button and what was the background. This damaged our usability for users while playing the Mini Arcade.
We realised the changes which could be made with help from our [user feedback](#updates-prompted-by-user-feedback).


<figure>
    <img src="After_GUI.png" alt="Testing" width="425" height="225" >
    <figcaption> <b> This is the interface prior to changes </b> </figcaption> 
</figure>

In the above image it shows the changes which were made to our interface which consists of the clear colour changes, change in text dimensions
and also a clear large title at the top of the portal.The colour change helps to add a more vibrant and eye-catching interface for the user, it also creates 
a clear difference between the game buttons and the background increasing usability for the user. The change with adding in a title in the portal to help again with the readability of
the programs game portal.

<figure>
    <img src="Before_TXT.png" alt="Testing" width="425" height="225" >
    <figcaption> <b> This is the TXT game before the changes </b> </figcaption> 
</figure>

The image above can show the simplicity in the previous txt code and how there is no way 
to determine what is a user prompt and what is an answer. It also frankly quite a boring design 
and is not engaging for the user what so ever.  


<figure>
    <img src="After_TXT.png" alt="Testing" width="425" height="225" >
    <figcaption> <b> This is the TXT game after the changes </b> </figcaption> 
</figure>

As you can see in the above image, we focused on making a clear difference between user prompts and also the answers 
given to enhance the players experience and make it more accessible by having a clearer concept.
the choice of the two colours is impactful aswell as the contrast between these is clear therefore they cannot be confused 
for eachother.


<figure>
    <img src="Blair-before-TTT.png" alt="Testing" width="425" height="225" >
    <figcaption> <b> This is the Tic Tac Toe game before the changes </b> </figcaption> 
</figure>

This image clearly shows how small the buttons were previously making it hard to view what the
computer generated responses. The interface is also bland and not at all appealing to the user.

<figure>
    <img src="Blair-after-TTT.png" alt="Testing" width="425" height="225" >
    <figcaption> <b> This is the Tic Tac Toe game after the changes </b> </figcaption> 
</figure>

The above image shows the improvements which were made as it incomperated the changes made
to the TXT file in terms of the users responses and the computers varying in colour. The text was also made 
larger making the buttons and responses clear to determine what they represented and it also created a much more eye-catching display.


[Back to Overview](#overview)





# Resources review

From start to finish our mini arcade has required lots of different resources
and tools to effectively create a successful project. Straight from the get-go
we needed the initial framework for the mini-arcade accessible via the myplace
Strathclyde page. This gave an initial base to build upon. These files were 
edited and would eventually turn into the mini arcade using different editors,
this was entirely dependent on the person and tools such as IntelliJ... (INPUT)
were used. Any editor that could work with java GUI and TXT would be appropriate
however apps such as IntelliJ are highly beneficial due to built-in resources 
such as the assistant which helps finish off the rest of your code which can 
help if stuck. Within our code each game had to make use of different libraries
such as swing to run GUI projects, random to select random numbers or strings 
in lists or arrays and scanner to print out end results. For certain games such
as Trivia an external text file was needed to run questions and allows the user
to add an infinite number of questions to the game. This is a temporary solution
however you could entirely skip this resource and build the questions in game 
and allow the user to add more. To ensure we were working on the right version,
GitLab was used between users to ensure this was the case and allowed us to make
sure there was no duplication or wasted resources.



# Updates prompted by user feedback

During our cognitive walkthrough, the groups of testers made many suggestions regarding our Mini 
Arcade that made us aware of several minor changes that we could make in order to improve the accessibility
of our game. The first change that we chose to highlight was the colour scheme of both our GUI and TXT elements. 
We proposed the change of colours to a selection specifically chosen to assist those with visual impairment, with 
the use of a main scheme of a navy blue and Cadmium Orange, a support scheme of Cyan and Yellow, which was incorporated 
into the TXT code in order to show a clear distinction between inputs and outputs.

Another choice that we made a priority was the size of the text itself. With the text being that small it 
could also pose a problem to people due to it being unreadable. To counter this, we increased the size of the 
text drastically within our GUI elements as well as choosing a legible font to go alongside it.

We also changed the size of our buttons and main frame as in our feedback we were told it had a small design therefore 
we had to make changes to improve accessiblity for users who wish to use our Mini Arcade.

[Back to Overview](#overview)


# Evaluation

Overall, we were successful in making the changes that we 
highlighted during planning. The changes we highlight were 
able to be successfully applied to our program and greatly 
improved its accessibility towards those with visual impairments.
However, we did make note that there were potentially others 
changes that could have been made to expand the range of people
that we targeted. For example, we discussed sounds being implemented
into the program itself that would trigger when certain actions 
were performed.

Despite our overall success in integrating our changes, we did come
to an issue with the changing of fonts within TXT. If we had managed
to be successful in this, it would have greatly increased the 
accessibility within the TXT games however we believe that our 
changes in color more than make up for this.

We ran into a problem with the use of GitLab and markdown as it was preventing multiple contributors
from commiting changes and pushing them to the repository. to combat this we used our microsoft teams to communicate
and created a document within the team which allowed us all to edit it. We then all knew what eachother was working
on and this prevented us from repetition.

## Non-functional requirements

One of the mini arcade non-functional requirements is accessibility.
If there was a settings bar the user could toggle on/off colour-blind mode,
making the game inclusive by modifying the looks of things for people with 
varying requirements; we could also add a setting to increase or decrease 
the size of the font.

The mini arcade program should be able to run on different platforms if 
java can be installed on the machine. We could have made it runnable on 
phones but that would have been out of our skill set which is quite unrealistic
for this project, so we left it at desktop machines.

As a group we made sure that regardless of what type of game we programmed,
it would be as usable as possible. For text-based programs we made sure there
was enough instructions for the game to be playable and for the GUI programs 
we made sure that we followed the same specific UI conventions used for the 
main menu of the mini arcade.

We made sure that the programs are reliable and that they wouldn’t take too 
long to load and did not lag. The quicker the program is, the better the 
overall user experience will be.

[Back to Overview](#overview)

## Functional requirements

Functional requirements are what are required for the game
to run without any problems that would cause it to stop working,
for our mini arcade there are requirements that are needed to be
met that to ensure the user has a good experience. This requires
all the menus to work with buttons taking the user to the right 
destination, the games must function according to how they were designed
to and therefore must not generate runtime errors, Scores need to work 
for games, consistency needs to be there. Games must also not crash the 
user’s computer and must run on every system. Some functional requirements
which were not met for our game due to time restraints and other priorities
were settings, settings could have been a way to boost accessibility and 
therefore our game may not be entirely readable to people who suffer with 
colour blindness and needed settings, Also user profiles would have been a 
functional way to keep high scores of each game for users and also getting 
their name would increase personalisation.

# Reflection
In reflection of this project I would say that the knowledge we gained from this really 
changed our perspective on how some simple changes can transform the accessibility of this
for much more users. For example, the simple TXT colour change between the [user prompt and the
answers](#before-and-after). This project has helped us realise a whole new aspect of changes which 
can be made to future projects to help improve the overall look and quality of them. For instance, the use 
of mark down can help writing the documentation to support the code being made and this project helped 
us get to grips with using it. We also realised the many different ways in which you can increase
the accessibility and overall usability of a program which again can be taken further into future assignments
and work.


[Back to Overview](#overview)
# Acknowledgements
The group heavily benefited from using resources provided by 
the week 8 lecture as it contained information regarding 
accessibility (Mitchell, 2025a) this is because we got to 
understand the
array of issues that may occur within a program if accessibility is not 
met for all types of users. The assignment instructions provided through 
GitLab were quintessential in our overall success as it provided a 
structure to how our work should be regulated and formatted(Mitchell, 2025b).
As a group we were also very strongly on increasing our understanding 
on the different types of users that may use our version of the Mini-Arcade
which is why we did extensive research on the various type of 
colour blindness (protanopia, deuteranopes, tritanopes) (Colour Blind Awareness, 2025),
this is so we could implement our code to be best suited for a wide range
of users. We were also cognizant of the glaring issues that kept on 
occurred no matter how much we modified our program as it’s very hard to 
appeal to every sort of user and if we had not researched this beforehand
by learning about how for example colour blindness works (Colour Blind Awareness, 2025)
it may have set us back even further as we would be trying to complete 
an impossible task.

Colour Blind Awareness (2025) ‘Types of Colour Blindness’. Available at: https://www.colourblindawareness.org/colour-blindness/types-of-colour-blindness/ (Accessed: 31 March 2025).
Mitchell, B. (2025a) ‘accessability’. Available at: https://gitlab.cis.strath.ac.uk/ykb24210/cs101-topics-4-materials-2025/-/blob/main/accessibility.md?ref_type=heads (Accessed: 31 March 2025).
Mitchell, B. (2025b) ‘reportexplainer’. Available at: https://gitlab.cis.strath.ac.uk/ykb24210/cs101-topics-4-assignment-instructions-2025/-/blob/main/reportExplainer.md?ref_type=heads (Accessed: 31 March 2025).


[Back to Overview](#overview)